/* Extra procedures needed for imap support
 * C Taylor 8/9/94 (C) Cov Uni
 */

#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <ctype.h>
#include <pwd.h>
#include <errno.h>
#include "headers.h"

char   *imap_passwd;
int     tt;


int     found_in_msg;

int keepalive()
{
	alarm(0);
	mail_ping(stream);	
	alarm(60);
	errno=EINTR;
}


void    init_imap () {
}

void    mm_flags (stream, number)
MAILSTREAM * stream;
long    number;
{
}

void    mm_searched (stream, number)
MAILSTREAM * stream;
long    number;
{
    found_in_msg = (int) number;
}


void    mm_exists (stream, number)
MAILSTREAM * stream;
long    number;
{
}


void    mm_expunged (stream, number)
MAILSTREAM * stream;
long    number;
{
}


void    mm_notify (stream, string, errflg)
MAILSTREAM * stream;
char   *string;
long    errflg;
{
    mm_log (string, errflg);
}


void    mm_mailbox (string)
char   *string;
{
    char    host[40];

    if ((sscanf (stream -> mailbox, "\{%[^\}]\}", host)) != 1) {
	printf ("{?}%s\n", host, string);
    }
    else {
	printf ("{%s}%s\n", host, string);
    }
}


void    mm_bboard (string)
char   *string;
{
    putchar (' ');
    puts (string);
}

/* Obvious......imaps error logging */
void    mm_log (string, errflg)
char   *string;
long    errflg;
{

    if ((short) errflg != NIL) {
	ClearScreen ();
    }

    tt = timeout;
    timeout = 5;

    switch ((short) errflg) {
	case NIL: 
	    break;
	case PARSE: 
	    error ("Mail folder corrupt !");
	    break;
	case WARN: 
	    error2 ("Warning: %s\n", string);
	    GetPrompt ();
	    break;
	case ERROR: 
	    error2 ("Error %s\n", string);
	    GetPrompt ();
	    break;
    }
    timeout = tt;
}


void    mm_dlog (string)
char   *string;
{
    error (string);
    tt = timeout;
    timeout = 5;
    GetPrompt ();
    timeout = tt;
}


/* This is the login procedure imap calls when opening a stream */
void    mm_login (host, user, pwd, trial)
char   *host;
char   *user;
char   *pwd;
long    trial;
{
    static  login_count = 0;
    struct passwd  *p;
    char    tmp[1024];

    /* Try 3 times to authenticate, then silently exit */
    if (login_count == 3) {
	silently_exit ();
    }

    /* Increment the login count */
    login_count++;

    /* If were root, then ask who we want to be */
    if ((getuid ()) == 0 || (p = getpwuid (getuid ())) == NULL) {
	ClearScreen ();
	Raw (OFF);
	sprintf (tmp, "{%s} username: ", host);
	printf ("Enter username: ");
	gets (user);
	Raw (ON);
	ClearScreen ();
    }
    else {
	strcpy (user, p -> pw_name);
    }
    tmp[0] = '\0';
    lower_prompt ("                         Enter password: ");
    display_central_message ();

    /* Get the password */
    optionally_enter (tmp, LINES - 1, 8, TRUE, TRUE);
    strcpy (pwd, tmp);
    imap_passwd = (char *) malloc (strlen (pwd) + 1);
    strcpy (imap_passwd, pwd);
}


void    mm_critical (stream)
MAILSTREAM * stream;
{
}


void    mm_nocritical (stream)
MAILSTREAM * stream;
{
}


long    mm_diskerror (stream, errcode, serious)
MAILSTREAM * stream;
long    errcode;
long    serious;
{
}


void    mm_fatal (string)
char   *string;
{
    error (string);
    tt = timeout;
    timeout = 5;
    GetPrompt ();
    timeout = tt;
}



/* this function creates a 'from' line - its rather bodgy but it works... */
char   *make_fromline (header,msg) 
char *header;
int msg;
{
    static char *dotw[7]={"Mon","Tue","Wed","Thu","Fri","Sat","Sun"};
    static char *moty[12]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
    
    static char from[256];
    static char date[256];
    int day;
    int i;

    int mon,year,c;   

    LONGCACHE *l;

    i=(msg-1);

    mail_fetchfrom (from, stream, msg, 254);
    memset(from,0,sizeof(from));
    
    l=stream->cache.l[i];
    if(l->elt.msgno != msg) {
	for(i=0;i < stream->nmsgs;i++) {
		l=stream->cache.l[i];
		if(l->elt.msgno == i) break;
	}
	if(i == stream->nmsgs) {
		return(NULL);
	}
    }

    year=l->elt.year+69;
    mon=l->elt.month-2;

    if(mon <= 0) {
	mon += 12;
	year--;
    }

    c=year/100;
    year-=(c * 100);

    day=(((26 * mon - 2) / 10) + 1 + ((5 * year) / 4) + (c / 4) - (2 * c)) % 7;
    day=((day + l->elt.day -1) % 7);

    sprintf(date,"%s %s %2d %02d:%02d:%02d %d\n",
        dotw[day],
	moty[l->elt.month-1],
	l->elt.day,
	l->elt.hours,
	l->elt.minutes,
	l->elt.seconds,
	l->elt.year+1969);

    if(l->env->from == NULL) {
	    static char dummy[256];
	    static char tmp[256];
	    int bytecount;
	    char *from_ptr;

	    for (from_ptr = header; from_ptr != NULL;) {
		    if (!strncmp (from_ptr, "From:", 5)) {
			char   *ptr;
			char   *newline;
			from_ptr += 5;
			for (ptr = from_ptr, bytecount = 0; *ptr != '\n' && *ptr != '\0'; bytecount++, ptr++)
					/* nothing */
			    ;
			while (*from_ptr != '\0' && isspace (*from_ptr))
			    from_ptr++, bytecount--;
			strncpy (from, from_ptr, bytecount);
			newline = index (from, '\r');
				if (newline != NULL)
				    *newline = '\0';
			newline = index (from, '\n');
			if (newline != NULL)
			    *newline = '\0';
			if (sscanf (from, "%[^<]<%[^>]", dummy, tmp) != 2)
				if (sscanf (from, "%[^(\n]", tmp) != 1) {
					strcpy (tmp, from);/* Anything Else */
					break;
				}
		    }
		from_ptr = index (from_ptr, '\n');
		if (from_ptr != NULL)
		from_ptr++;
	    }
	    if(*from == '\0') {
		    sprintf(from,"From Unknown %s",date);
	    } else {
		    sprintf(from,"From %s %s",tmp,date);
	    }
    } else {
	    sprintf(from,"From %s@%s %s",l->env->from->mailbox,l->env->from->host,date);
    }
	

    return (from);
}


void    trim_slashr (s) 
char *s;
{
    char   *p;
    for (p = s; p != NULL && *p != '\0'; p++) {
	if (*p == '\r')
	    *p = ' ';
    }
}



imap_newfolder (name) 
char *name;
{
    extern  DRIVER imapdriver;
    static int  loadeddriver = 0;
    char   *old_mbox = NULL;

    char   *angle;

    if (loadeddriver == 0) {
	mail_link (&imapdriver);
	loadeddriver = 1;
    }
    else {
	old_mbox = (char *) malloc (strlen (stream -> mailbox) + 1);
	strcpy (old_mbox, stream -> mailbox);
    }

    stream = mail_open (stream, name, 0);
    if (stream == NIL) {
	if (old_mbox != NULL) {
	    stream = mail_open (stream, old_mbox, 0);
	    free (old_mbox);
	}
	return (0);
    }

    angle = index (stream -> mailbox, '<');
    if (angle != NULL) {
	if (!strncmp (angle, "<no_mailbox>", strlen ("<no_mailbox>"))) {
	    if (old_mbox != NULL) {
		stream = mail_open (stream, old_mbox, 0);
		free (old_mbox);
	    }
	    return (0);
	}
    }
    if (old_mbox != NULL) {
	free (old_mbox);
    }
    return (1);
}


long    line_count (s) 
char *s;
{
    long    count = 0;

    for (; s != NULL && *s != '\0'; s++)
	if (*s == '\n')
	    count++;
    if (s[-1] != '\n')
	count++;
    return (count);
}


